CREATE TABLE XLS.WORKBOOKS (
  ID NUMBER,
  NAME VARCHAR2(128) NOT NULL,
  TEMPLATE VARCHAR2(255),
  DEFINITION NCLOB NOT NULL,
  CONSTRAINT PK_WORKBOOKS PRIMARY KEY (ID)
);

CREATE SEQUENCE XLS.SQ_WORKBOOKS_ID
  INCREMENT BY 1
  START WITH 21
  MAXVALUE 1E28
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER;

CREATE TRIGGER XLS.TR_WORKBOOKS_ID
  BEFORE INSERT OR UPDATE
  ON XLS.WORKBOOKS
REFERENCING NEW AS NEW OLD AS OLD FOR EACH ROW
BEGIN
  IF :NEW.ID IS NULL THEN
    SELECT SQ_WORKBOOKS_ID.NEXTVAL INTO :NEW.ID FROM DUAL;
  END IF;
END;
/

CREATE UNIQUE INDEX XLS.IX_WORKBOOKS ON XLS.WORKBOOKS (NAME);

GRANT SELECT ON XLS.WORKBOOKS       TO XLS_USERS;

GRANT DELETE, INSERT, SELECT, UPDATE ON XLS.WORKBOOKS    TO XLS_DEVELOPERS;

GRANT SELECT ON XLS.SQ_WORKBOOKS_ID     TO XLS_DEVELOPERS;

INSERT INTO XLS.HANDLERS (TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, EVENT_NAME, HANDLER_SCHEMA, HANDLER_NAME, HANDLER_TYPE, HANDLER_CODE, TARGET_WORKSHEET, MENU_ORDER, EDIT_PARAMETERS) VALUES ('XLS', 'WORKBOOKS',    NULL, 'Actions', 'HTTP', 'Online Help', 'HTTP', 'http://www.savetodb.com/savetodb8/configuring-workbooks.htm',         NULL, 11, NULL);
